Gecode::Search::Seq::DFS< Tracer > Class Template Reference

Depth-first search engine implementation. More...

`#include <dfs.hh>`

## Public Member Functions

| DFS (Space *s, const Options &o)
| Initialize for space s with options o.
Space * | next (void)
| Search for next solution
Statistics | statistics (void) const
| Return statistics.
void | constrain (const Space &b)
| Constrain future solutions to be better than b (should never be called).
void | reset (Space *s)
| Reset engine to restart at space s.
NoGoods & | nogoods (void)
| Return no-goods.
| ~DFS (void)
| Destructor.
Public Member Functions inherited from Gecode::Search::Worker
| Worker (void)
| Initialize.
void | start (void)
| Reset stop information.
bool | stop (const Options &o)
| Check whether engine must be stopped.
bool | stopped (void) const
| Check whether engine has been stopped.
void | reset (unsigned long int d=0)
| Reset statistics with root depth d.
void | stack_depth (unsigned long int d)
| Record stack depth d.
unsigned long int | steal_depth (unsigned long int d) const
| Return steal depth.
Public Member Functions inherited from Gecode::Search::Statistics
| Statistics (void)
| Initialize.
void | reset (void)
| Reset.
Statistics | operator+ (const Statistics &s)
| Return sum with s.
Statistics & | operator+= (const Statistics &s)
| Increment by statistics s.
Public Member Functions inherited from Gecode::StatusStatistics
| StatusStatistics (void)
| Initialize.
void | reset (void)
| Reset information.
StatusStatistics | operator+ (const StatusStatistics &s)
| Return sum with s.
StatusStatistics & | operator+= (const StatusStatistics &s)
| Increment by statistics s.

## Additional Inherited Members

Public Attributes inherited from Gecode::Search::Statistics
unsigned long int | fail
| Number of failed nodes in search tree.
unsigned long int | node
| Number of nodes expanded.
unsigned long int | depth
| Maximum depth of search stack.
unsigned long int | restart
| Number of restarts.
unsigned long int | nogood
| Number of no-goods posted.
Public Attributes inherited from Gecode::StatusStatistics
unsigned long int | propagate
| Number of propagator executions.
Protected Attributes inherited from Gecode::Search::Worker
bool | _stopped
| Whether engine has been stopped.
unsigned long int | root_depth
| Depth of root node (for work stealing).

## Detailed Description

template<class Tracer>
class Gecode::Search::Seq::DFS< Tracer >

Depth-first search engine implementation.

Definition at line 46 of file dfs.hh.

## Constructor & Destructor Documentation

## DFS()

template<class Tracer>

Gecode::Search::Seq::DFS< Tracer >::DFS | ( | Space * | s,
|  | const Options & | o )

inline

Initialize for space s with options o.

Definition at line 38 of file dfs.hpp.

## ~DFS()

template<class Tracer>

Gecode::Search::Seq::DFS< Tracer >::~DFS | ( | void |  | ) |

inline

Destructor.

Definition at line 177 of file dfs.hpp.

## Member Function Documentation

## next()

template<class Tracer>

Space * Gecode::Search::Seq::DFS< Tracer >::next | ( | void |  | ) |

inline

Search for next solution

Definition at line 78 of file dfs.hpp.

## statistics()

template<class Tracer>

Statistics Gecode::Search::Seq::DFS< Tracer >::statistics | ( | void |  | ) | const

inline

Return statistics.

Definition at line 164 of file dfs.hpp.

## constrain()

template<class Tracer>

void Gecode::Search::Seq::DFS< Tracer >::constrain | ( | const Space & | b | ) |

inline

Constrain future solutions to be better than b (should never be called).

Definition at line 170 of file dfs.hpp.

## reset()

template<class Tracer>

void Gecode::Search::Seq::DFS< Tracer >::reset | ( | Space * | s | ) |

inline

Reset engine to restart at space s.

Definition at line 56 of file dfs.hpp.

## nogoods()

template<class Tracer>

NoGoods & Gecode::Search::Seq::DFS< Tracer >::nogoods | ( | void |  | ) |

inline

Return no-goods.

Definition at line 72 of file dfs.hpp.

The documentation for this class was generated from the following files:

- gecode/search/seq/dfs.hh
- gecode/search/seq/dfs.hpp